#ifndef NAG_FORTRAN_ROUTINES_H
#define NAG_FORTRAN_ROUTINES_H

/* The following are used in the C library. In order to use the same utility files, 
   we need to give them a value here.
*/
#define Integer long
#define Nag_Boolean int
#define Nag_TRUE 1
#define Nag_FALSE 0

/* Values used in the prototypes of the Fortran routines */
#define NAG_fortran_integer int
#define CONST const

#ifdef __cplusplus
extern "C" {
#endif
/* These prototypes were taken from the header file supplied with the NAG Fortran library */
extern void __stdcall E04WBF(
  CONST char rname[], 
  NAG_fortran_integer length_rname,
  CONST char cwsav[], 
  NAG_fortran_integer length_cwsav,
  CONST NAG_fortran_integer *lcwsav,
  NAG_fortran_integer lwsav[],
  CONST NAG_fortran_integer *llwsav,
  CONST NAG_fortran_integer iwsav[],
  CONST NAG_fortran_integer *liwsav,
  CONST double rwsav[],
  CONST NAG_fortran_integer *lrwsav,
  NAG_fortran_integer *ifail
);

extern void __stdcall E04ABA(
  void (__stdcall *fun)(double *, double *, NAG_fortran_integer[], double[]),
  double *eps,
  double *t,
  double *a,
  double *b,
  NAG_fortran_integer *maxcal,
  double *x,
  double *f,
  NAG_fortran_integer iuser[],
  double ruser[],
  NAG_fortran_integer *ifail
);

extern void __stdcall E04UCA(
  CONST NAG_fortran_integer *n,
  CONST NAG_fortran_integer *nclin,
  CONST NAG_fortran_integer *ncnln,
  CONST NAG_fortran_integer *lda,
  CONST NAG_fortran_integer *ldcj,
  CONST NAG_fortran_integer *ldr,
  double a[] /* 2 dimension */,
  CONST double bl[],
  CONST double bu[],
  void (__stdcall *confun)(NAG_fortran_integer *, NAG_fortran_integer *, NAG_fortran_integer *, NAG_fortran_integer *, 
                           NAG_fortran_integer[], double[], double[], double[], NAG_fortran_integer *, NAG_fortran_integer[], double[]),
  void (__stdcall *objfun)(NAG_fortran_integer *, NAG_fortran_integer *, double[], double *, double[], NAG_fortran_integer *, 
                           NAG_fortran_integer[], double[]),
  NAG_fortran_integer *iter,
  NAG_fortran_integer istate[],
  double c[],
  double cjac[] /* 2 dimension */,
  double clamda[],
  double *objf,
  double objgrad[],
  double r[] /* 2 dimension */,
  double x[],
  NAG_fortran_integer iw[],
  CONST NAG_fortran_integer *leniw,
  double w[],
  CONST NAG_fortran_integer *lenw,
  NAG_fortran_integer iuser[],
  double user[],
  NAG_fortran_integer lwsav[],
  NAG_fortran_integer iwsav[],
  double rwsav[],
  NAG_fortran_integer *ifail
);

extern void __stdcall E04UEA(
  CONST char string[], 
  NAG_fortran_integer length_string,
  NAG_fortran_integer lwsav[],
  NAG_fortran_integer iwsav[],
  double rwsav[],
  NAG_fortran_integer *inform
);

extern void __stdcall X04ABF(
  CONST NAG_fortran_integer *i,
  NAG_fortran_integer *nadv
);

extern void __stdcall X04ACF(
  CONST NAG_fortran_integer *nout,
  CONST char file[], 
  NAG_fortran_integer length_file,
  CONST NAG_fortran_integer *mode,
  NAG_fortran_integer *ifail
);

extern void __stdcall X04ADF(
  CONST NAG_fortran_integer *nout,
  NAG_fortran_integer *ifail
);
#ifdef __cplusplus
}
#endif

#endif
